-----------------------------------------------------------------
--  control.vhd
--			Steuersignale fuer LCD124
--			=========================
--
--  07.10.97	Bodo Wenzel	Erstellung
--  26.03.98	Bodo Wenzel	Hardware fertig
-----------------------------------------------------------------

-- Interface ----------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity control is
  port (clock:    in  std_ulogic;
        ctl_byte: out std_ulogic;
        ctl_wr:   out std_ulogic);
end;

-- Implementation -----------------------------------------------

architecture beh of control is
  signal count: unsigned(2 downto 0) := (others => '0');
begin
  process (clock)
  begin
    if rising_edge(clock) then
      count <= count+1;

      ctl_wr <= not count(2) and not count(1);
    end if;
  end process;

  ctl_byte <= std_ulogic(count(2));
end;

-- Ende ---------------------------------------------------------
