-----------------------------------------------------------------
--  pll.vhd
--			PLL fuer LCD124
--			===============
--
--  04.10.97	Bodo Wenzel	Erstellung
--  24.03.98	Bodo Wenzel	Hardware fertig
-----------------------------------------------------------------

-- Interface ----------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

entity pll is
  port (clock:   in  std_ulogic;
        hsync_x: in  std_ulogic;
        hsync_i: in  std_ulogic;
        pll_up:  out std_ulogic;
        pll_dn:  out std_ulogic);
end;

-- Implementation -----------------------------------------------

architecture beh of pll is
  signal pll_reset_up: std_ulogic;
  signal pll_reset_dn: std_ulogic;
  signal i_pll_up:     std_ulogic;
  signal i_pll_dn:     std_ulogic;
begin
  pll_reset: process (clock)
  begin
    if rising_edge(clock) then
      pll_reset_up <= i_pll_dn or hsync_i;
      pll_reset_dn <= i_pll_up or hsync_x;
    end if;
  end process;

  regulate_up: process (pll_reset_up,hsync_x)
  begin
    if pll_reset_up='1' then
      i_pll_up <= '0';
    elsif rising_edge(hsync_x) then
      i_pll_up <= '1';
    end if;
  end process;

  pll_up <= i_pll_up;

  regulate_dn: process (pll_reset_dn,hsync_i)
  begin
    if pll_reset_dn='1' then
      i_pll_dn <= '0';
    elsif rising_edge(hsync_i) then
      i_pll_dn <= '1';
    end if;
  end process;

  pll_dn <= i_pll_dn;
end;

-- Ende ---------------------------------------------------------
